<?php
/*
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2021 digital guru GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

/**
 * Standard-Icon-Set.
 *
 * @package GhGui
 * @subpackage core
 * @category PHP-GUI-Kernklassen
 *
 * @author digital guru GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 digital guru GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhGuiDefaultIconSet extends GhGuiIconSet
{
  /**
   * Konstruktor.
   *
   * @param string $iconsUrl URL der Bilddatei für die Icons
   * @param array  $icons    Liste der Icons
   */
  public function __construct($iconsUrl = null, $icons = null)
  {
    parent::__construct('ghgui://lib/greyhound/dojo/theme/images/ghicons.png');

    $this->_iconClass = 'ghGuiDefaultIcons';
    $this->setIconsDisabledUrl('ghgui://lib/greyhound/dojo/theme/images/ghicons-disabled.png');
  }

  /**
   * Liefer die Stylesheet-Datei dieses Icon-Sets.
   *
   * @return string
   */
  public function getStylesheetUrl()
  {
    return 'ghgui://lib/greyhound/dojo/theme/ghicons.css';
  }

  /**
   * Liefert den CSS Code für dieses Icon-Set.
   *
   * @return string
   */
  public function getCss()
  {
    return '';
  }
}