<?php
/**
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2021 GREYHOUND Software GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */


/**
 * RPC-Unit rpc_icloudsynclib.
 *
 * @package GhRpc
 * @subpackage rpc_icloudsynclib
 * @category PHP-RPC-Units
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class rpc_icloudsynclib extends GhRpcLibrary
{
  // RpcICloudSyncSyncPhoto Konstanten:

  /**
   * icsspYes Konstante (gehört zum Enum: RpcICloudSyncSyncPhoto).
   */
  const icsspYes = 0;
  /**
   * icsspNo Konstante (gehört zum Enum: RpcICloudSyncSyncPhoto).
   */
  const icsspNo = 1;

  // RpcICloudSyncUseProxy Konstanten:

  /**
   * icsupYes Konstante (gehört zum Enum: RpcICloudSyncUseProxy).
   */
  const icsupYes = 0;
  /**
   * icsupNo Konstante (gehört zum Enum: RpcICloudSyncUseProxy).
   */
  const icsupNo = 1;

  // RpcICloudSyncSyncUserFields Konstanten:

  /**
   * icssufYes Konstante (gehört zum Enum: RpcICloudSyncSyncUserFields).
   */
  const icssufYes = 0;
  /**
   * icssufNo Konstante (gehört zum Enum: RpcICloudSyncSyncUserFields).
   */
  const icssufNo = 1;

  // RpcICloudSyncUpSync Konstanten:

  /**
   * icsusYes Konstante (gehört zum Enum: RpcICloudSyncUpSync).
   */
  const icsusYes = 0;
  /**
   * icsusNo Konstante (gehört zum Enum: RpcICloudSyncUpSync).
   */
  const icsusNo = 1;

  // RpcICloudSyncDownSync Konstanten:

  /**
   * icsdsYes Konstante (gehört zum Enum: RpcICloudSyncDownSync).
   */
  const icsdsYes = 0;
  /**
   * icsdsNo Konstante (gehört zum Enum: RpcICloudSyncDownSync).
   */
  const icsdsNo = 1;

  // RpcWorkSpace Konstanten:

  /**
   * wsSystem Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsSystem = 0;
  /**
   * wsPersonal Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsPersonal = 1;
  /**
   * wsForbidden Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsForbidden = 2;

  // RpcICloudSyncKind Konstanten:

  /**
   * icskContacts Konstante (gehört zum Enum: RpcICloudSyncKind).
   */
  const icskContacts = 0;
  /**
   * icskCalendar Konstante (gehört zum Enum: RpcICloudSyncKind).
   */
  const icskCalendar = 1;

  // RpcICloudSyncState Konstanten:

  /**
   * icssInactive Konstante (gehört zum Enum: RpcICloudSyncState).
   */
  const icssInactive = 0;
  /**
   * icssActive Konstante (gehört zum Enum: RpcICloudSyncState).
   */
  const icssActive = 1;

  // RpcLockState Konstanten:

  /**
   * IsUnlocked Konstante (gehört zum Enum: RpcLockState).
   */
  const IsUnlocked = 0;
  /**
   * IsModified Konstante (gehört zum Enum: RpcLockState).
   */
  const IsModified = 1;
  /**
   * IsLocked Konstante (gehört zum Enum: RpcLockState).
   */
  const IsLocked = 2;

  /**
   * Hilfskonstante, die ein Set darstellt, in dem alle Enums gesetzt sind.
   * @var int
   */
  const SET_ALL = -1;


  /**
   * Erzeugt eine Instanz des RPC-Dienstes RpcICloudSync.
   *
   * @param GhRpcClient $client Client Instanz
   *
   * @return GhRpcIcloudsynclibRpcICloudSync
   */
  public static function newRpcICloudSync(GhRpcClient $client)
  {
    return new GhRpcIcloudsynclibRpcICloudSync($client);
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcICloudSyncConnection.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcIcloudsynclibRpcICloudSyncConnection
   */
  public static function newRpcICloudSyncConnection($fillProperties = false)
  {
    $object = new GhRpcIcloudsynclibRpcICloudSyncConnection();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcICloudSyncAccount.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcIcloudsynclibRpcICloudSyncAccount
   */
  public static function newRpcICloudSyncAccount($fillProperties = false)
  {
    $object = new GhRpcIcloudsynclibRpcICloudSyncAccount();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcLockData.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcIcloudsynclibRpcLockData
   */
  public static function newRpcLockData($fillProperties = false)
  {
    $object = new GhRpcIcloudsynclibRpcLockData();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }
}


/**
 * RPC-Struct RpcICloudSyncAccountList.
 *
 * @package GhRpc
 * @subpackage rpc_icloudsynclib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcIcloudsynclibRpcLockData extends GhRpcStruct
{
  /**
   * LockState
   * @var int
   */
  public $LockState;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'LockState' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcICloudSyncAccountList.
 *
 * @package GhRpc
 * @subpackage rpc_icloudsynclib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcIcloudsynclibRpcICloudSyncAccount extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * WorkSpace
   * @var int
   */
  public $WorkSpace;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * GroupName
   * @var string
   */
  public $GroupName;

  /**
   * DownSync
   * @var int
   */
  public $DownSync;

  /**
   * FilterRef
   * @var int
   */
  public $FilterRef;

  /**
   * ColorRef
   * @var int
   */
  public $ColorRef;

  /**
   * SyncUserFields
   * @var int
   */
  public $SyncUserFields;

  /**
   * SyncPhoto
   * @var int
   */
  public $SyncPhoto;

  /**
   * UpSync
   * @var int
   */
  public $UpSync;

  /**
   * UseProxy
   * @var int
   */
  public $UseProxy;

  /**
   * ProxyHost
   * @var string
   */
  public $ProxyHost;

  /**
   * ProxyPort
   * @var int
   */
  public $ProxyPort;

  /**
   * Timeout
   * @var int
   */
  public $Timeout;

  /**
   * Username
   * @var string
   */
  public $Username;

  /**
   * Password
   * @var string
   */
  public $Password;

  /**
   * ResetSync
   * @var boolean
   */
  public $ResetSync;

  /**
   * LockData
   * @var GhRpcIcloudsynclibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'WorkSpace' => 'int',
    'State' => 'int',
    'Kind' => 'int',
    'Name' => 'string',
    'GroupName' => 'string',
    'DownSync' => 'int',
    'FilterRef' => 'int',
    'ColorRef' => 'int',
    'SyncUserFields' => 'int',
    'SyncPhoto' => 'int',
    'UpSync' => 'int',
    'UseProxy' => 'int',
    'ProxyHost' => 'string',
    'ProxyPort' => 'int',
    'Timeout' => 'int',
    'Username' => 'string',
    'Password' => 'string',
    'ResetSync' => 'boolean',
    'LockData' => 'GhRpcIcloudsynclibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcICloudSyncAccountList.
 *
 * @package GhRpc
 * @subpackage rpc_icloudsynclib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcIcloudsynclibRpcICloudSyncConnection extends GhRpcStruct
{
  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * UseProxy
   * @var int
   */
  public $UseProxy;

  /**
   * ProxyHost
   * @var string
   */
  public $ProxyHost;

  /**
   * ProxyPort
   * @var int
   */
  public $ProxyPort;

  /**
   * Timeout
   * @var int
   */
  public $Timeout;

  /**
   * Username
   * @var string
   */
  public $Username;

  /**
   * Password
   * @var string
   */
  public $Password;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Kind' => 'int',
    'UseProxy' => 'int',
    'ProxyHost' => 'string',
    'ProxyPort' => 'int',
    'Timeout' => 'int',
    'Username' => 'string',
    'Password' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Dienst RpcICloudSync
 *
 * @package GhRpc
 * @subpackage rpc_icloudsynclib
 * @category PHP-RPC-Dienste
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcIcloudsynclibRpcICloudSync extends GhRpcService
{
  /**
   * RPC-Methoden mit Parametern und Ergebnistypen.
   * @var array
   */
  protected static $_rpcMethods = array(
    'GetLockData' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcIcloudsynclibRpcLockData',
    ),
    'Unlock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Lock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'CheckConnection' => array(
      'params' => array(
        'Connection' => 'GhRpcIcloudsynclibRpcICloudSyncConnection',
      ),
      'return' => 'array:string',
    ),
    'Delete' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Put' => array(
      'params' => array(
        'Account' => 'GhRpcIcloudsynclibRpcICloudSyncAccount',
      ),
      'return' => '',
    ),
    'New_' => array(
      'params' => array(
        'Account' => 'GhRpcIcloudsynclibRpcICloudSyncAccount',
      ),
      'return' => 'int',
    ),
    'GetCompleteList' => array(
      'params' => array(
      ),
      'return' => 'array:GhRpcIcloudsynclibRpcICloudSyncAccount',
    ),
    'GetList' => array(
      'params' => array(
      ),
      'return' => 'array:GhRpcIcloudsynclibRpcICloudSyncAccount',
    ),
    'Get' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcIcloudsynclibRpcICloudSyncAccount',
    ),
  );


  /**
   * Ruft die RPC-Funktion RpcICloudSync.Get auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcIcloudsynclibRpcICloudSyncAccount
   */
  public function Get($ID = 0)
  {
    return $this->_sendRpcRequest('RpcICloudSync.Get', array($ID), self::$_rpcMethods['Get']);
  }

  /**
   * Ruft die RPC-Funktion RpcICloudSync.GetList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return array
   */
  public function GetList()
  {
    return $this->_sendRpcRequest('RpcICloudSync.GetList', array(), self::$_rpcMethods['GetList']);
  }

  /**
   * Ruft die RPC-Funktion RpcICloudSync.GetCompleteList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return array
   */
  public function GetCompleteList()
  {
    return $this->_sendRpcRequest('RpcICloudSync.GetCompleteList', array(), self::$_rpcMethods['GetCompleteList']);
  }

  /**
   * Ruft die RPC-Funktion RpcICloudSync.New auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcIcloudsynclibRpcICloudSyncAccount $Account
   *
   * @return int
   */
  public function New_(GhRpcIcloudsynclibRpcICloudSyncAccount $Account = null)
  {
    return $this->_sendRpcRequest('RpcICloudSync.New', array($Account), self::$_rpcMethods['New_']);
  }

  /**
   * Ruft die RPC-Funktion RpcICloudSync.Put auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcIcloudsynclibRpcICloudSyncAccount $Account
   */
  public function Put(GhRpcIcloudsynclibRpcICloudSyncAccount $Account = null)
  {
    return $this->_sendRpcRequest('RpcICloudSync.Put', array($Account), self::$_rpcMethods['Put']);
  }

  /**
   * Ruft die RPC-Funktion RpcICloudSync.Delete auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Delete($ID = 0)
  {
    return $this->_sendRpcRequest('RpcICloudSync.Delete', array($ID), self::$_rpcMethods['Delete']);
  }

  /**
   * Ruft die RPC-Funktion RpcICloudSync.CheckConnection auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcIcloudsynclibRpcICloudSyncConnection $Connection
   *
   * @return array
   */
  public function CheckConnection(GhRpcIcloudsynclibRpcICloudSyncConnection $Connection = null)
  {
    return $this->_sendRpcRequest('RpcICloudSync.CheckConnection', array($Connection), self::$_rpcMethods['CheckConnection']);
  }

  /**
   * Ruft die RPC-Funktion RpcICloudSync.Lock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Lock($ID = 0)
  {
    return $this->_sendRpcRequest('RpcICloudSync.Lock', array($ID), self::$_rpcMethods['Lock']);
  }

  /**
   * Ruft die RPC-Funktion RpcICloudSync.Unlock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Unlock($ID = 0)
  {
    return $this->_sendRpcRequest('RpcICloudSync.Unlock', array($ID), self::$_rpcMethods['Unlock']);
  }

  /**
   * Ruft die RPC-Funktion RpcICloudSync.GetLockData auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcIcloudsynclibRpcLockData
   */
  public function GetLockData($ID = 0)
  {
    return $this->_sendRpcRequest('RpcICloudSync.GetLockData', array($ID), self::$_rpcMethods['GetLockData']);
  }
}
