<?php
/**
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2022 GREYHOUND Software GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */


/**
 * RPC-Unit rpc_userslib.
 *
 * @package GhRpc
 * @subpackage rpc_userslib
 * @category PHP-RPC-Units
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class rpc_userslib extends GhRpcLibrary
{
  // RpcUserFieldVisible Konstanten:

  /**
   * ufvNo Konstante (gehört zum Enum: RpcUserFieldVisible).
   */
  const ufvNo = 0;
  /**
   * ufvYes Konstante (gehört zum Enum: RpcUserFieldVisible).
   */
  const ufvYes = 1;
  /**
   * ufvConditional Konstante (gehört zum Enum: RpcUserFieldVisible).
   */
  const ufvConditional = 2;

  // RpcFormatItemKind Konstanten:

  /**
   * fikEmail Konstante (gehört zum Enum: RpcFormatItemKind).
   */
  const fikEmail = 0;
  /**
   * fikFax Konstante (gehört zum Enum: RpcFormatItemKind).
   */
  const fikFax = 1;
  /**
   * fikLetter Konstante (gehört zum Enum: RpcFormatItemKind).
   */
  const fikLetter = 2;
  /**
   * fikMessage Konstante (gehört zum Enum: RpcFormatItemKind).
   */
  const fikMessage = 3;
  /**
   * fikCall Konstante (gehört zum Enum: RpcFormatItemKind).
   */
  const fikCall = 4;
  /**
   * fikAppointment Konstante (gehört zum Enum: RpcFormatItemKind).
   */
  const fikAppointment = 5;
  /**
   * fikTask Konstante (gehört zum Enum: RpcFormatItemKind).
   */
  const fikTask = 6;
  /**
   * fikNote Konstante (gehört zum Enum: RpcFormatItemKind).
   */
  const fikNote = 7;
  /**
   * fikContact Konstante (gehört zum Enum: RpcFormatItemKind).
   */
  const fikContact = 8;
  /**
   * fikFile Konstante (gehört zum Enum: RpcFormatItemKind).
   */
  const fikFile = 9;

  // RpcOnlineState Konstanten:

  /**
   * osOffline Konstante (gehört zum Enum: RpcOnlineState).
   */
  const osOffline = 0;
  /**
   * osAvailable Konstante (gehört zum Enum: RpcOnlineState).
   */
  const osAvailable = 1;
  /**
   * osOnline Konstante (gehört zum Enum: RpcOnlineState).
   */
  const osOnline = 2;
  /**
   * osDND Konstante (gehört zum Enum: RpcOnlineState).
   */
  const osDND = 3;

  // RpcUserFieldDataType Konstanten:

  /**
   * ufdtString Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtString = 0;
  /**
   * ufdtInteger Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtInteger = 1;
  /**
   * ufdtInt64 Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtInt64 = 2;
  /**
   * ufdtBoolean Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtBoolean = 3;
  /**
   * ufdtDateTime Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtDateTime = 4;
  /**
   * ufdtFloat Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtFloat = 5;
  /**
   * ufdtBlob Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtBlob = 6;
  /**
   * ufdtCurrency Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtCurrency = 7;
  /**
   * ufdtList Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtList = 8;

  // RpcFormatForward Konstanten:

  /**
   * ffText Konstante (gehört zum Enum: RpcFormatForward).
   */
  const ffText = 0;
  /**
   * ffHtml Konstante (gehört zum Enum: RpcFormatForward).
   */
  const ffHtml = 1;
  /**
   * ffAutomatic Konstante (gehört zum Enum: RpcFormatForward).
   */
  const ffAutomatic = 2;

  // RpcFormatAnswer Konstanten:

  /**
   * faText Konstante (gehört zum Enum: RpcFormatAnswer).
   */
  const faText = 0;
  /**
   * faHtml Konstante (gehört zum Enum: RpcFormatAnswer).
   */
  const faHtml = 1;
  /**
   * faAutomatic Konstante (gehört zum Enum: RpcFormatAnswer).
   */
  const faAutomatic = 2;

  // RpcFormatNew Konstanten:

  /**
   * fnText Konstante (gehört zum Enum: RpcFormatNew).
   */
  const fnText = 0;
  /**
   * fnHtml Konstante (gehört zum Enum: RpcFormatNew).
   */
  const fnHtml = 1;

  // RpcLockState Konstanten:

  /**
   * lsUnlocked Konstante (gehört zum Enum: RpcLockState).
   */
  const lsUnlocked = 0;
  /**
   * lsModified Konstante (gehört zum Enum: RpcLockState).
   */
  const lsModified = 1;
  /**
   * lsLocked Konstante (gehört zum Enum: RpcLockState).
   */
  const lsLocked = 2;

  // RpcUserState Konstanten:

  /**
   * usInactive Konstante (gehört zum Enum: RpcUserState).
   */
  const usInactive = 0;
  /**
   * usActive Konstante (gehört zum Enum: RpcUserState).
   */
  const usActive = 1;

  /**
   * Hilfskonstante, die ein Set darstellt, in dem alle Enums gesetzt sind.
   * @var int
   */
  const SET_ALL = -1;


  /**
   * Erzeugt eine Instanz des RPC-Dienstes RpcUsers.
   *
   * @param GhRpcClient $client Client Instanz
   *
   * @return GhRpcUserslibRpcUsers
   */
  public static function newRpcUsers(GhRpcClient $client)
  {
    return new GhRpcUserslibRpcUsers($client);
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcUserFieldItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcUserslibRpcUserFieldItem
   */
  public static function newRpcUserFieldItem($fillProperties = false)
  {
    $object = new GhRpcUserslibRpcUserFieldItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcItemFormat.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcUserslibRpcItemFormat
   */
  public static function newRpcItemFormat($fillProperties = false)
  {
    $object = new GhRpcUserslibRpcItemFormat();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcLockData.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcUserslibRpcLockData
   */
  public static function newRpcLockData($fillProperties = false)
  {
    $object = new GhRpcUserslibRpcLockData();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcUserItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcUserslibRpcUserItem
   */
  public static function newRpcUserItem($fillProperties = false)
  {
    $object = new GhRpcUserslibRpcUserItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcUserInfo.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcUserslibRpcUserInfo
   */
  public static function newRpcUserInfo($fillProperties = false)
  {
    $object = new GhRpcUserslibRpcUserInfo();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcUser.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcUserslibRpcUser
   */
  public static function newRpcUser($fillProperties = false)
  {
    $object = new GhRpcUserslibRpcUser();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }
}


/**
 * RPC-Struct RpcUserFieldList.
 *
 * @package GhRpc
 * @subpackage rpc_userslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcUserslibRpcUser extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * ProfileRef
   * @var int
   */
  public $ProfileRef;

  /**
   * ProfileName
   * @var string
   */
  public $ProfileName;

  /**
   * CategoryRefs
   * @var array
   */
  public $CategoryRefs;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Username
   * @var string
   */
  public $Username;

  /**
   * Password
   * @var string
   */
  public $Password;

  /**
   * FormattedName
   * @var string
   */
  public $FormattedName;

  /**
   * SupervisorRef
   * @var int
   */
  public $SupervisorRef;

  /**
   * Signature
   * @var string
   */
  public $Signature;

  /**
   * Picture
   * @var string
   */
  public $Picture;

  /**
   * OnlineState
   * @var int
   */
  public $OnlineState;

  /**
   * UserFields
   * @var array
   */
  public $UserFields;

  /**
   * Login
   * @var GhRpcDateTime
   */
  public $Login;

  /**
   * LockData
   * @var GhRpcUserslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'ProfileRef' => 'int',
    'ProfileName' => 'string',
    'CategoryRefs' => 'array:int',
    'State' => 'int',
    'Username' => 'string',
    'Password' => 'string',
    'FormattedName' => 'string',
    'SupervisorRef' => 'int',
    'Signature' => 'binary',
    'Picture' => 'binary',
    'OnlineState' => 'int',
    'UserFields' => 'array:GhRpcUserslibRpcUserFieldItem',
    'Login' => 'GhRpcDateTime',
    'LockData' => 'GhRpcUserslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcUserFieldList.
 *
 * @package GhRpc
 * @subpackage rpc_userslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcUserslibRpcUserInfo extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * Token
   * @var string
   */
  public $Token;

  /**
   * SystemRights
   * @var array
   */
  public $SystemRights;

  /**
   * PersonalRights
   * @var array
   */
  public $PersonalRights;

  /**
   * DownFileExts
   * @var array
   */
  public $DownFileExts;

  /**
   * UpFileExts
   * @var array
   */
  public $UpFileExts;

  /**
   * ItemFormats
   * @var array
   */
  public $ItemFormats;

  /**
   * Username
   * @var string
   */
  public $Username;

  /**
   * FormattedName
   * @var string
   */
  public $FormattedName;

  /**
   * Signature
   * @var string
   */
  public $Signature;

  /**
   * Picture
   * @var string
   */
  public $Picture;

  /**
   * OnlineState
   * @var int
   */
  public $OnlineState;

  /**
   * UserFields
   * @var array
   */
  public $UserFields;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'Token' => 'string',
    'SystemRights' => 'array:string',
    'PersonalRights' => 'array:string',
    'DownFileExts' => 'array:string',
    'UpFileExts' => 'array:string',
    'ItemFormats' => 'array:GhRpcUserslibRpcItemFormat',
    'Username' => 'string',
    'FormattedName' => 'string',
    'Signature' => 'binary',
    'Picture' => 'binary',
    'OnlineState' => 'int',
    'UserFields' => 'array:GhRpcUserslibRpcUserFieldItem',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcUserFieldList.
 *
 * @package GhRpc
 * @subpackage rpc_userslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcUserslibRpcUserItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * ProfileRef
   * @var int
   */
  public $ProfileRef;

  /**
   * ProfileName
   * @var string
   */
  public $ProfileName;

  /**
   * CategoryRefs
   * @var array
   */
  public $CategoryRefs;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Username
   * @var string
   */
  public $Username;

  /**
   * FormattedName
   * @var string
   */
  public $FormattedName;

  /**
   * SupervisorRef
   * @var int
   */
  public $SupervisorRef;

  /**
   * OnlineState
   * @var int
   */
  public $OnlineState;

  /**
   * Login
   * @var GhRpcDateTime
   */
  public $Login;

  /**
   * Picture
   * @var string
   */
  public $Picture;

  /**
   * LockData
   * @var GhRpcUserslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'ProfileRef' => 'int',
    'ProfileName' => 'string',
    'CategoryRefs' => 'array:int',
    'State' => 'int',
    'Username' => 'string',
    'FormattedName' => 'string',
    'SupervisorRef' => 'int',
    'OnlineState' => 'int',
    'Login' => 'GhRpcDateTime',
    'Picture' => 'binary',
    'LockData' => 'GhRpcUserslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcUserFieldList.
 *
 * @package GhRpc
 * @subpackage rpc_userslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcUserslibRpcLockData extends GhRpcStruct
{
  /**
   * LockState
   * @var int
   */
  public $LockState;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'LockState' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcUserFieldList.
 *
 * @package GhRpc
 * @subpackage rpc_userslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcUserslibRpcItemFormat extends GhRpcStruct
{
  /**
   * New
   * @var int
   */
  public $New;

  /**
   * Answer
   * @var int
   */
  public $Answer;

  /**
   * Forward
   * @var int
   */
  public $Forward;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'New' => 'int',
    'Answer' => 'int',
    'Forward' => 'int',
    'Kind' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcUserFieldList.
 *
 * @package GhRpc
 * @subpackage rpc_userslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcUserslibRpcUserFieldItem extends GhRpcStruct
{
  /**
   * FieldRef
   * @var int
   */
  public $FieldRef;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Description
   * @var string
   */
  public $Description;

  /**
   * Visible
   * @var int
   */
  public $Visible;

  /**
   * Condition
   * @var string
   */
  public $Condition;

  /**
   * Highlight
   * @var boolean
   */
  public $Highlight;

  /**
   * ReadOnly
   * @var boolean
   */
  public $ReadOnly;

  /**
   * DataType
   * @var int
   */
  public $DataType;

  /**
   * Validation
   * @var string
   */
  public $Validation;

  /**
   * Values
   * @var string
   */
  public $Values;

  /**
   * Regex
   * @var string
   */
  public $Regex;

  /**
   * DisplayFormat
   * @var string
   */
  public $DisplayFormat;

  /**
   * Value
   * @var string
   */
  public $Value;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'FieldRef' => 'int',
    'Name' => 'string',
    'Description' => 'string',
    'Visible' => 'int',
    'Condition' => 'string',
    'Highlight' => 'boolean',
    'ReadOnly' => 'boolean',
    'DataType' => 'int',
    'Validation' => 'string',
    'Values' => 'string',
    'Regex' => 'string',
    'DisplayFormat' => 'string',
    'Value' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Dienst RpcUsers
 *
 * @package GhRpc
 * @subpackage rpc_userslib
 * @category PHP-RPC-Dienste
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcUserslibRpcUsers extends GhRpcService
{
  /**
   * RPC-Methoden mit Parametern und Ergebnistypen.
   * @var array
   */
  protected static $_rpcMethods = array(
    'GetUserFieldList' => array(
      'params' => array(
      ),
      'return' => 'array:GhRpcUserslibRpcUserFieldItem',
    ),
    'Kick' => array(
      'params' => array(
        'ID' => 'int',
        'ClientName' => 'string',
      ),
      'return' => '',
    ),
    'PutSettings' => array(
      'params' => array(
        'ProductID' => 'string',
        'Settings' => 'string',
      ),
      'return' => '',
    ),
    'GetSettings' => array(
      'params' => array(
        'ProductID' => 'string',
      ),
      'return' => 'string',
    ),
    'GetLockData' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcUserslibRpcLockData',
    ),
    'Unlock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Lock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Logout' => array(
      'params' => array(
      ),
      'return' => '',
    ),
    'SetOnlineState' => array(
      'params' => array(
        'OnlineState' => 'int',
      ),
      'return' => '',
    ),
    'AddCategory' => array(
      'params' => array(
        'ID' => 'int',
        'CategoryRef' => 'int',
      ),
      'return' => '',
    ),
    'SetProfile' => array(
      'params' => array(
        'ID' => 'int',
        'ProfileRef' => 'int',
      ),
      'return' => '',
    ),
    'Delete' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Put' => array(
      'params' => array(
        'User' => 'GhRpcUserslibRpcUser',
      ),
      'return' => '',
    ),
    'New_' => array(
      'params' => array(
        'User' => 'GhRpcUserslibRpcUser',
      ),
      'return' => 'int',
    ),
    'GetList' => array(
      'params' => array(
        'AdvancedFields' => 'boolean',
      ),
      'return' => 'array:GhRpcUserslibRpcUserItem',
    ),
    'GetUserInfo' => array(
      'params' => array(
      ),
      'return' => 'GhRpcUserslibRpcUserInfo',
    ),
    'Get' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcUserslibRpcUser',
    ),
  );


  /**
   * Ruft die RPC-Funktion RpcUsers.Get auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcUserslibRpcUser
   */
  public function Get($ID = 0)
  {
    return $this->_sendRpcRequest('RpcUsers.Get', array($ID), self::$_rpcMethods['Get']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.GetUserInfo auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return GhRpcUserslibRpcUserInfo
   */
  public function GetUserInfo()
  {
    return $this->_sendRpcRequest('RpcUsers.GetUserInfo', array(), self::$_rpcMethods['GetUserInfo']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.GetList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param boolean $AdvancedFields
   *
   * @return array
   */
  public function GetList($AdvancedFields = false)
  {
    return $this->_sendRpcRequest('RpcUsers.GetList', array($AdvancedFields), self::$_rpcMethods['GetList']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.New auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcUserslibRpcUser $User
   *
   * @return int
   */
  public function New_(GhRpcUserslibRpcUser $User = null)
  {
    return $this->_sendRpcRequest('RpcUsers.New', array($User), self::$_rpcMethods['New_']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.Put auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcUserslibRpcUser $User
   */
  public function Put(GhRpcUserslibRpcUser $User = null)
  {
    return $this->_sendRpcRequest('RpcUsers.Put', array($User), self::$_rpcMethods['Put']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.Delete auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Delete($ID = 0)
  {
    return $this->_sendRpcRequest('RpcUsers.Delete', array($ID), self::$_rpcMethods['Delete']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.SetProfile auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $ProfileRef
   */
  public function SetProfile($ID = 0, $ProfileRef = 0)
  {
    return $this->_sendRpcRequest('RpcUsers.SetProfile', array($ID, $ProfileRef), self::$_rpcMethods['SetProfile']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.AddCategory auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $CategoryRef
   */
  public function AddCategory($ID = 0, $CategoryRef = 0)
  {
    return $this->_sendRpcRequest('RpcUsers.AddCategory', array($ID, $CategoryRef), self::$_rpcMethods['AddCategory']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.SetOnlineState auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $OnlineState
   */
  public function SetOnlineState($OnlineState = 0)
  {
    return $this->_sendRpcRequest('RpcUsers.SetOnlineState', array($OnlineState), self::$_rpcMethods['SetOnlineState']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.Logout auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   */
  public function Logout()
  {
    return $this->_sendRpcRequest('RpcUsers.Logout', array(), self::$_rpcMethods['Logout']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.Lock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Lock($ID = 0)
  {
    return $this->_sendRpcRequest('RpcUsers.Lock', array($ID), self::$_rpcMethods['Lock']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.Unlock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Unlock($ID = 0)
  {
    return $this->_sendRpcRequest('RpcUsers.Unlock', array($ID), self::$_rpcMethods['Unlock']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.GetLockData auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcUserslibRpcLockData
   */
  public function GetLockData($ID = 0)
  {
    return $this->_sendRpcRequest('RpcUsers.GetLockData', array($ID), self::$_rpcMethods['GetLockData']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.GetSettings auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $ProductID
   *
   * @return string
   */
  public function GetSettings($ProductID = '')
  {
    return $this->_sendRpcRequest('RpcUsers.GetSettings', array($ProductID), self::$_rpcMethods['GetSettings']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.PutSettings auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $ProductID
   * @param string $Settings
   */
  public function PutSettings($ProductID = '', $Settings = '')
  {
    return $this->_sendRpcRequest('RpcUsers.PutSettings', array($ProductID, $Settings), self::$_rpcMethods['PutSettings']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.Kick auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param string $ClientName
   */
  public function Kick($ID = 0, $ClientName = '')
  {
    return $this->_sendRpcRequest('RpcUsers.Kick', array($ID, $ClientName), self::$_rpcMethods['Kick']);
  }

  /**
   * Ruft die RPC-Funktion RpcUsers.GetUserFieldList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return array
   */
  public function GetUserFieldList()
  {
    return $this->_sendRpcRequest('RpcUsers.GetUserFieldList', array(), self::$_rpcMethods['GetUserFieldList']);
  }
}
