/*
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2013 digital guru GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

dojo.provide("greyhound.dojo.Iframe");

dojo.require("dijit._Widget");

dojo.declare("greyhound.dojo.Iframe", [dijit._Widget],
{
  url: null,
  isInitialized: false,

  resize: function(dim)
  {
    this.inherited(arguments);

    // IFrame Größe setzen:
    if(dim)
    {
      dojo.attr(this.srcNodeRef, "width", dim.w);
      dojo.attr(this.srcNodeRef, "height", dim.h);
    }

    // Inhalt des IFrames erst laden, wenn dieses tatsächlich angezeigt wird,
    // da sonst im Firefox ein Javascript-Fehler aufgrund der noch nicht
    // gesetzten Größe auftritt (Fehlermeldung: "s is null").
    if(!this.isInitialized)
    {
      this.isInitialized = true;
      this.srcNodeRef.src = this.url;
    }
  },

  setUrl: function(url)
  {
    this.url = url;

    if(this.isInitialized)
      this.srcNodeRef.src = this.url;
  }
});
